/*
 * Copyright (c) 2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 *
 * http://hardware.ispras.ru
 *
 * This code implements working with standard linux context.
 */

#include "sync.c"

using namespace cpptesk::ts;

static CppTestScenario *__localcppscen;
static CppTestScenario *__localcppinitscen;

static void cpp_scenario_wrapper(void)
{
    if(!netscenario)
        localmain(&TE_NDFSM, __localcppscen, parsed_argc, parsed_argv);
    else
        netmain(&TE_NDFSM, __localcppscen, parsed_argc, parsed_argv);
}

static void cpp_scenario_wrapper_with_init(void)
{
    localmain(&TE_NDFSM, __localcppinitscen, parsed_argc, parsed_argv);
    if(!netscenario)
        localmain(&TE_NDFSM, __localcppscen, parsed_argc, parsed_argv);
    else
        netmain(&TE_NDFSM, __localcppscen, parsed_argc, parsed_argv);
}

static void cpp_scenario_wrapper_new(void)
{
    if(!netscenario)
        localmain(local_testEngine, __localcppscen, parsed_argc, parsed_argv);
    else
        netmain(local_testEngine, __localcppscen, parsed_argc, parsed_argv);
}
static void cpp_scenario_wrapper_with_init_new(void)
{
    localmain(local_testEngine, __localcppscen, parsed_argc, parsed_argv);
    if(!netscenario)
        localmain(local_testEngine, __localcppscen, parsed_argc, parsed_argv);
    else
        netmain(local_testEngine, __localcppscen, parsed_argc, parsed_argv);
}
int start_scenario_new(CppTestScenario *scen, TestEngine *testEngine, char *params, bool netscen, bool initscen)
{
	__localcppscen = scen;
    local_testEngine = testEngine;
    parse_parameters(params, __localcppscen->name);
    netscenario = netscen;
    initscenario = initscen;

	getcontext(&scenario_context);

	scenario_context.uc_link = &testbench_context;
    scenario_context.uc_stack.ss_sp = stack;
    scenario_context.uc_stack.ss_size = SIGSTKSZ;

	makecontext(&scenario_context, initscenario ? cpp_scenario_wrapper_with_init_new : cpp_scenario_wrapper_new, 0);
    swapcontext(&testbench_context, &scenario_context);

	return 0;
}

int start_scenario(CppTestScenario *scen, char *params)
{
    __localcppscen = scen;
    parse_parameters(params, __localcppscen->name);

    getcontext(&scenario_context);
    scenario_context.uc_link = &testbench_context;
    scenario_context.uc_stack.ss_sp = stack;
    scenario_context.uc_stack.ss_size = SIGSTKSZ;
    makecontext(&scenario_context, initscenario ? cpp_scenario_wrapper_with_init : cpp_scenario_wrapper, 0);
    swapcontext(&testbench_context, &scenario_context);

    return 0;
}

int start_net_scenario(CppTestScenario *scen, char *params)
{
    netscenario = true;
    return start_scenario(scen, params);
}

int start_scenario_with_init(CppTestScenario *initscen, cpptesk::ts::CppTestScenario *scen, char *params)
{
    __localcppinitscen = initscen;
    initscenario    = true;
    return start_scenario(scen, params);
}

int start_net_scenario_with_init(CppTestScenario *initscen, cpptesk::ts::CppTestScenario *scen, char *params)
{
    netscenario = true;
    return start_scenario_with_init(initscen, scen, params);
}

